// *** AUTOGENERATED FILE - Do not edit manually! - Changes will be overwritten! *** //

#include "generated/receiver.h"
#include "generated/checksum.h"


bool parseMessage(BufferAccessor* buffer, MessageHandler* handler) {
    for (size_t availableSize = buffer->availableBytes(buffer);
         availableSize >= sizeof(TelemetryMessageHeader);
         buffer->advance(buffer, 1), availableSize--) {
        uint8_t byteRead;
        if (!buffer->peek(buffer, &byteRead, sizeof(byteRead), 0) || byteRead != SYNC_BYTE_1 ||
            !buffer->peek(buffer, &byteRead, sizeof(byteRead), 1) || byteRead != SYNC_BYTE_2) {
            continue;
        }
        TelemetryMessageHeader header;
        if (!buffer->peek(buffer, &header, sizeof(header), 0)) {
            return false;
        }
        switch (header.type) {
        case TELEMETRY_HEARTBEAT: {
            size_t dataSize = 4;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            ms_t time;
            buffer->peek(buffer, &time, sizeof(time), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageHeartbeat(handler, time);
            return true;
        }
        case TELEMETRY_RESPONSE: {
            size_t dataSize = 65;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint8_t commandNumber;
            buffer->peek(buffer, &commandNumber, sizeof(commandNumber), sizeof(header));
            uint8_t value[MAX_TELECOMMAND_RESPONSE_SIZE];
            buffer->peek(buffer, &value, sizeof(value), sizeof(header) + 1);
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageResponse(handler, commandNumber, value);
            return true;
        }
        case TELEMETRY_ACKNOWLEDGE: {
            size_t dataSize = 1;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            uint8_t commandNumber;
            buffer->peek(buffer, &commandNumber, sizeof(commandNumber), sizeof(header));
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageAcknowledge(handler, commandNumber);
            return true;
        }
        case TELEMETRY_MESSAGE: {
            size_t dataSize = 0;
            ms_t time;
            if (!buffer->peek(buffer, &time, sizeof(time), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += sizeof(ms_t);
            uint8_t type;
            if (!buffer->peek(buffer, &type, sizeof(type), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += sizeof(uint8_t);
            uint16_t size;
            if (!buffer->peek(buffer, &size, sizeof(size), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += sizeof(uint16_t);
            if (size > 512) {
                handler->errorHandler(handler, DYNAMIC_SIZE_TOO_LARGE);
                continue;
            }
            char message[size];
            if (!buffer->peek(buffer, &message, sizeof(message), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += size;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageMessage(handler, time, type, size, message);
            return true;
        }
        case TELEMETRY_DATA1: {
            size_t dataSize = 58;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            ms_t time;
            buffer->peek(buffer, &time, sizeof(time), sizeof(header));
            celsius_t processorTemperature;
            buffer->peek(buffer, &processorTemperature, sizeof(processorTemperature), sizeof(header) + 4);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            celsius_t batteryTemperature;
            buffer->peek(buffer, &batteryTemperature, sizeof(batteryTemperature), sizeof(header) + 8);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            celsius_t PduPcbTemperature;
            buffer->peek(buffer, &PduPcbTemperature, sizeof(PduPcbTemperature), sizeof(header) + 12);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            celsius_t motorControllerTemperature;
            buffer->peek(buffer, &motorControllerTemperature, sizeof(motorControllerTemperature), sizeof(header) + 16);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            celsius_t motorBracketTemperature;
            buffer->peek(buffer, &motorBracketTemperature, sizeof(motorBracketTemperature), sizeof(header) + 20);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            celsius_t retentionWallTemperature;
            buffer->peek(buffer, &retentionWallTemperature, sizeof(retentionWallTemperature), sizeof(header) + 24);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            celsius_t recoveryWallTemperature;
            buffer->peek(buffer, &recoveryWallTemperature, sizeof(recoveryWallTemperature), sizeof(header) + 28);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            celsiusInt8_t primaryImuTemperature;
            buffer->peek(buffer, &primaryImuTemperature, sizeof(primaryImuTemperature), sizeof(header) + 32);
            celsiusInt8_t secondaryImuTemperature;
            buffer->peek(buffer, &secondaryImuTemperature, sizeof(secondaryImuTemperature), sizeof(header) + 33);
            Vec3F motorCurrent;
            buffer->peek(buffer, &motorCurrent, sizeof(motorCurrent), sizeof(header) + 34);
            Vec3F secondaryImuRotation;
            buffer->peek(buffer, &secondaryImuRotation, sizeof(secondaryImuRotation), sizeof(header) + 46);
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageData1(handler, time, processorTemperature, batteryTemperature, PduPcbTemperature, motorControllerTemperature, motorBracketTemperature, retentionWallTemperature, recoveryWallTemperature, primaryImuTemperature, secondaryImuTemperature, motorCurrent, secondaryImuRotation);
            return true;
        }
        case TELEMETRY_DATA2: {
            size_t dataSize = 57;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            ms_t time;
            buffer->peek(buffer, &time, sizeof(time), sizeof(header));
            mps2_t primaryXAcceleration;
            buffer->peek(buffer, &primaryXAcceleration, sizeof(primaryXAcceleration), sizeof(header) + 4);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            mps2_t primaryYAcceleration;
            buffer->peek(buffer, &primaryYAcceleration, sizeof(primaryYAcceleration), sizeof(header) + 8);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            mps2_t primaryZAcceleration;
            buffer->peek(buffer, &primaryZAcceleration, sizeof(primaryZAcceleration), sizeof(header) + 12);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            microTesla_t primaryXMagneticForce;
            buffer->peek(buffer, &primaryXMagneticForce, sizeof(primaryXMagneticForce), sizeof(header) + 16);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            microTesla_t primaryYMagneticForce;
            buffer->peek(buffer, &primaryYMagneticForce, sizeof(primaryYMagneticForce), sizeof(header) + 20);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            microTesla_t primaryZMagneticForce;
            buffer->peek(buffer, &primaryZMagneticForce, sizeof(primaryZMagneticForce), sizeof(header) + 24);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            mps2_t secondaryXAcceleration;
            buffer->peek(buffer, &secondaryXAcceleration, sizeof(secondaryXAcceleration), sizeof(header) + 28);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            mps2_t secondaryYAcceleration;
            buffer->peek(buffer, &secondaryYAcceleration, sizeof(secondaryYAcceleration), sizeof(header) + 32);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            mps2_t secondaryZAcceleration;
            buffer->peek(buffer, &secondaryZAcceleration, sizeof(secondaryZAcceleration), sizeof(header) + 36);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            microTesla_t secondaryXMagneticForce;
            buffer->peek(buffer, &secondaryXMagneticForce, sizeof(secondaryXMagneticForce), sizeof(header) + 40);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            microTesla_t secondaryYMagneticForce;
            buffer->peek(buffer, &secondaryYMagneticForce, sizeof(secondaryYMagneticForce), sizeof(header) + 44);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            microTesla_t secondaryZMagneticForce;
            buffer->peek(buffer, &secondaryZMagneticForce, sizeof(secondaryZMagneticForce), sizeof(header) + 48);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            bar_t pressure;
            buffer->peek(buffer, &pressure, sizeof(pressure), sizeof(header) + 52);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            uint8_t state;
            buffer->peek(buffer, &state, sizeof(state), sizeof(header) + 56);
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageData2(handler, time, primaryXAcceleration, primaryYAcceleration, primaryZAcceleration, primaryXMagneticForce, primaryYMagneticForce, primaryZMagneticForce, secondaryXAcceleration, secondaryYAcceleration, secondaryZAcceleration, secondaryXMagneticForce, secondaryYMagneticForce, secondaryZMagneticForce, pressure, state);
            return true;
        }
        case TELEMETRY_DATA3: {
            size_t dataSize = 40;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            ms_t time;
            buffer->peek(buffer, &time, sizeof(time), sizeof(header));
            Quaternion orientation;
            buffer->peek(buffer, &orientation, sizeof(orientation), sizeof(header) + 4);
            voltFloat_t batteryLevel;
            buffer->peek(buffer, &batteryLevel, sizeof(batteryLevel), sizeof(header) + 36);
            static_assert(sizeof(float) == 4,
                "float has an invalid size on this platform and can not be used");
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageData3(handler, time, orientation, batteryLevel);
            return true;
        }
        case TELEMETRY_DATA_MOTOR_SPEEDS: {
            size_t dataSize = 0;
            uint8_t motorSpeedCount;
            if (!buffer->peek(buffer, &motorSpeedCount, sizeof(motorSpeedCount), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += sizeof(uint8_t);
            if (motor speed count > 512) {
                handler->errorHandler(handler, DYNAMIC_SIZE_TOO_LARGE);
                continue;
            }
            Vec3FWithTime motorSpeeds[motor speed count];
            if (!buffer->peek(buffer, &motorSpeeds, sizeof(motorSpeeds), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += motor speed count;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageDataMotorSpeeds(handler, motorSpeedCount, motorSpeeds);
            return true;
        }
        case TELEMETRY_DATA_ROTATION_SPEEDS: {
            size_t dataSize = 0;
            uint8_t rotationSpeedCount;
            if (!buffer->peek(buffer, &rotationSpeedCount, sizeof(rotationSpeedCount), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += sizeof(uint8_t);
            if (rotation speed count > 512) {
                handler->errorHandler(handler, DYNAMIC_SIZE_TOO_LARGE);
                continue;
            }
            Vec3FWithTime rotationSpeeds[rotation speed count];
            if (!buffer->peek(buffer, &rotationSpeeds, sizeof(rotationSpeeds), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += rotation speed count;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageDataRotationSpeeds(handler, rotationSpeedCount, rotationSpeeds);
            return true;
        }
        case TELEMETRY_DATA_SET_POINTS: {
            size_t dataSize = 0;
            uint8_t setPointsCount;
            if (!buffer->peek(buffer, &setPointsCount, sizeof(setPointsCount), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += sizeof(uint8_t);
            if (set points count > 512) {
                handler->errorHandler(handler, DYNAMIC_SIZE_TOO_LARGE);
                continue;
            }
            Vec3Int32WithTime setPoints[set points count];
            if (!buffer->peek(buffer, &setPoints, sizeof(setPoints), sizeof(header) + dataSize)) {
                return false;
            }
            dataSize += set points count;
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageDataSetPoints(handler, setPointsCount, setPoints);
            return true;
        }
        case TELEMETRY_DATA_RECOVERY: {
            size_t dataSize = 33;
            if (buffer->availableBytes(buffer) < dataSize) {
                return false;
            }
            ms_t time;
            buffer->peek(buffer, &time, sizeof(time), sizeof(header));
            ms_t gpsTime;
            buffer->peek(buffer, &gpsTime, sizeof(gpsTime), sizeof(header) + 4);
            deg_t longitude;
            buffer->peek(buffer, &longitude, sizeof(longitude), sizeof(header) + 8);
            static_assert(sizeof(double) == 8,
                "double has an invalid size on this platform and can not be used");
            deg_t latitude;
            buffer->peek(buffer, &latitude, sizeof(latitude), sizeof(header) + 16);
            static_assert(sizeof(double) == 8,
                "double has an invalid size on this platform and can not be used");
            meter_t height;
            buffer->peek(buffer, &height, sizeof(height), sizeof(header) + 24);
            static_assert(sizeof(double) == 8,
                "double has an invalid size on this platform and can not be used");
            uint8_t recoveryState;
            buffer->peek(buffer, &recoveryState, sizeof(recoveryState), sizeof(header) + 32);
            size_t checksumStartOffset =
                sizeof(header.syncByte1) + sizeof(header.syncByte2) + sizeof(header.checksum);
            if (header.checksum != calculateChecksumFromBuffer(buffer,
                    sizeof(TelemetryMessageHeader) - checksumStartOffset + dataSize,
                    checksumStartOffset)) {
                handler->errorHandler(handler, CHECKSUM_ERROR);
                continue;
            }
            buffer->advance(buffer, sizeof(header) + dataSize);
            handler->handleMessageDataRecovery(handler, time, gpsTime, longitude, latitude, height, recoveryState);
            return true;
        }
        default:
            handler->errorHandler(handler, INVALID_MESSAGE);
        }
    }
    return false;
}
